package teddy;

import java.awt.*;
import java.lang.*;



public class Vector2 {
	
	// 2D vecoter
	// double x,y
	// vector2(Point, Point)
	// double inner_product(Vector2)
	// double get_cos(Vector2)
	// double distance(x1,y1,x2,y2)
	

	public double x;
	public double y;
	

	//Vector2(Node start, Node end){
	//	x = end.x -  start.x;
	//	y = end.y -  start.y;
	//}

	public Vector2(Point start, Point end){
		x = end.x -  start.x;
		y = end.y -  start.y;
	}
	
	Vector2(Vector2 start, Vector2 end){
		x = end.x -  start.x;
		y = end.y -  start.y;
	}

	Vector2(Point p){
		x = p.x;
		y = p.y;
	}
	Vector2(){
	}
	public Vector2(double _x, double _y){
		x = _x;
		y = _y;
	}
    	
	




	public Vector2 flip_y_axis(){
	    return new Vector2(-x, y);
	}
	// ͕ςȂB
	public Vector2 rotate(double degree){
	    if (degree == 90)
		return new Vector2(-y, x);
	    else if (degree == 180)
		return new Vector2(-x, -y);
	    else if (degree == 270)
		return new Vector2(y, -x);

	    
	    double radian = degree * Math.PI / 180.0;
	    double cos = Math.cos(radian);
	    double sin = Math.sin(radian);

	    return  new Vector2(x * cos - y * sin,
				x * sin + y * cos );
	}

	// ͕ςȂB
    	protected Vector2 add(Vector2 v){
		return new Vector2(x + v.x, y + v.y);
    	}

	// ͕ςȂB
	public Vector2 normalize(){
	    double length = length();
	    if (length == 0) length = 1;
	    return new Vector2(x / length, y / length);
	}	
	public Vector2 get_normalized(){
	    double length = length();
	    if (length == 0) length = 1;
	    return new Vector2(x / length, y / length);
	}
	// gkB͕ςȂB
	public Vector2 scale(double scale){
	    return new Vector2(x * scale, y *scale);
	}
    	public Vector2 multiple(double m){
	    return new Vector2(x * m, y * m);
   	}
    	public void multiple_self(double m){
	    x *= m;
	    y *= m;
   	}
    	public void add_self(Vector2 v){
	    x += v.x;
	    y += v.y;
   	}
	public void rotate90_self(){
	    double xx = x;
	    double yy = y;
	    x = -y;
	    y = x;	
	}
	public Vector2 rotate90(){
	    return new Vector2(-y, x);
	}
 

	// ς
	public void normalize_self(){
	    double length = length();
	    if (length == 0) length = 1;
	    x = x/length;
	    y = y/length;
	}

	public double length(){
	  return Math.sqrt(x*x + y*y);
	}

	public double inner_product(Vector2 v){
		return x * v.x + y * v.y;
	}
	public double outer_product(Vector2 v){
		return x * v.y - y * v.x;
	}
	public double dot_product(Vector2 v){
		return x * v.x + y * v.y;
	}
	public double cross_product(Vector2 v){
		return x * v.y - y * v.x;
	}

	public double get_cos(Vector2 v){
	  double length = 
	    Math.sqrt( (x*x + y*y)*(v.x*v.x + v.y*v.y) );
	  if (length >0)
	    return inner_product(v) / length;
	  else
	    return 0;
	}

	public double get_sin(Vector2 v){
	  double length = 
	    Math.sqrt( (x*x + y*y)*(v.x*v.x + v.y*v.y) );
	  if (length >0)
	    return cross_product(v) / length;
	  else
	    return 0;
	}  

	public double sin(Vector2 v){
		return get_sin(v);
	}	
	public double cos(Vector2 v){
		return get_cos(v);
	}	

   // n_vƂ̋p߂B0-PI Polygon2.set_normal()
    public double get_relative_angle(Vector2 v){
	double cosine = cos(v);
	if (cosine <= -1) return Math.PI;
	else if (cosine >= 1) return 0;
	else return Math.acos(cos(v));
    }

	/** 0-360 SilhuetteFind.cusp ֌Wŋ܂Ă邩`FbNɎgB */
	// Skeleton  J-loop ɂgB
	public double get_angle(Vector2 v){
		double cos = get_cos(v);
		double sin = get_sin(v);
		if (cos == 0)
			if (sin > 0)	return 90;
			else		return 270;
		if (sin == 0)
			if (cos > 0)	return 0;
			else		return 180;
		
		// -PI/2   ...   +PI/2
		double angle = 180 * Math.atan(sin/cos) / Math.PI;

		if (cos < 0)
			angle = angle + 180;
		if (angle < 0)
			angle = angle + 360;
		return angle;
	}
		


	public static double distance(int x1, int y1, int x2, int y2){
	  return Math.sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
	}
	public static double distance(Point start, Point end){
	  return distance(start.x, start.y, end.x, end.y);
	}
	public static double distance(double x1, double y1, double x2, double y2){
	  return Math.sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
	}
	public static Vector2 interporate(Point start, Point end, double t){
	  return new Vector2( start.x * (1-t) + end.x * t, start.y * (1-t) + end.y * t);
	}
	public Point point(){
		return new Point((int)x, (int)y);
	}




	public static double distance(Vertex2D start, Vertex2D end){
	  return distance(start.x, start.y, end.x, end.y);
	}

	public Vertex2D vertex2D(){
		return new Vertex2D(x, y);
	}


}
