package ui;

import edu.cmu.cs.stage3.alice.scenegraph.*;
import edu.cmu.cs.stage3.math.*;

import java.awt.Graphics;
import java.awt.Point;
import java.util.*;


public class BlockCopyHelper extends Helper
{
	public Suggestion makeSuggestion(Chateau chateau){
	
		if (chateau.currentLines.size() <= 2)
			return null;
			
		Line currentLine = chateau.currentLine();
		
		Vector connected0 = currentLine.gatherConnectedLines(chateau.currentLines);
		
		if (connected0.size() != 1)
			return null;
			
		Line prevLine = (Line) chateau.currentLines.elementAt(chateau.currentLines.size()-2);
		
		Vector connected1 = prevLine.gatherConnectedLines(chateau.currentLines);
		if (connected1.size() != chateau.currentLines.size()-1)
			return null;
		
		
		Vector3 vec0 = currentLine.getVector3();
		Vector3 vec1 = prevLine.getVector3();
		if (Math.abs(vec0.getLength()-vec1.getLength())>Chateau.ERROR)
			return null;
			
		vec0.normalize();
		vec1.normalize();
		double cos = Vector3.dotProduct(vec0, vec1);
		
		Vector3 newBase;
		if (cos > 1-Chateau.ERROR) 
			newBase = currentLine.startJoint.position;
		else if (cos < -1+Chateau.ERROR)
			newBase = currentLine.endJoint.position;
		else
			return null;
			
			
		Vector3 oldBase = prevLine.startJoint.position;
			
		
			
		// let's make a suggestion!!	
		World originalWorld = 	new World(chateau);

		Vector lines = new Vector();
		for(int i=0; i<chateau.currentLines.size()-1; i++)
			lines.addElement(chateau.currentLines.elementAt(i));
		
		Vector plates = new Vector();
		Hashtable hash = new Hashtable();
		
		for(int i=0; i<lines.size(); i++){
			Line oldLine = (Line) lines.elementAt(i);
			Vector3 start = oldLine.startJoint.position;
			Vector3 end = oldLine.endJoint.position;
			
			Joint startJoint = chateau.findJoint(Vector3.add(newBase, Vector3.subtract(start, oldBase)));
			Joint endJoint = chateau.findJoint(Vector3.add(newBase, Vector3.subtract(end, oldBase)));
			
			Line newLine = new Line(startJoint, endJoint);
			Line line0 = chateau.addLine(newLine);
			
			chateau.addCurrentLine(line0);
			
			hash.put(oldLine, line0);
			for(int j=0; j<oldLine.plates.size(); j++){
				Plate plate = (Plate) oldLine.plates.elementAt(j);
				if (!plates.contains(plate))
					plates.addElement(plate);
			}
		}
		
		for(int i=0; i<plates.size(); i++){
			Plate plate = (Plate) plates.elementAt(i);
			Vector newLines = new Vector();
			for(int j=0; j<plate.lines.size(); j++){
				Line oldLine = (Line) plate.lines.elementAt(j);
				Line newLine = (Line) hash.get(oldLine);
				if (newLine == null){
					newLines = null;
					break;
				}
				newLines.addElement(newLine);
			}
			if (newLines != null)
				chateau.addPlate(new Plate(newLines));
		}
		
		
		chateau.addCurrentLine(prevLine);
		chateau.addCurrentLine(currentLine);
				
		chateau.switchPlane(chateau.ground);

		Suggestion suggestion = new Suggestion(chateau, "BlockCopy");
		chateau.restoreWorld(originalWorld);
		return suggestion;
	}












	/*
	public Suggestion makeSuggestion(Chateau chateau){
	
		if (chateau.currentLines.size() != 1)
			return null;
		if (chateau.prevCurrentLines.size() <= 1)
			return null;
			
	
		Line currentLine = chateau.currentLine();
		Line prevLine = (Line)chateau.prevCurrentLines.elementAt(chateau.prevCurrentLines.size()-1);
		
		Vector3 vec0 = currentLine.getVector3();
		vec0.normalize();
		Vector3 vec1 = prevLine.getVector3();
		vec1.normalize();
		double cos = Vector3.dotProduct(vec0, vec1);
		
		Vector3 newBase;
		if (cos == 1) 
			newBase = currentLine.startJoint.position;
		else if (cos == -1)
			newBase = currentLine.endJoint.position;
		else
			return null;
			
			
		Vector3 oldBase = prevLine.startJoint.position;
			
		
			
		// let's make a suggestion!!	
		World originalWorld = 	new World(chateau);

		Vector lines = chateau.prevCurrentLines;
		
		for(int i=0; i<lines.size()-1; i++){
			Line oldLine = (Line) lines.elementAt(i);
			Vector3 start = oldLine.startJoint.position;
			Vector3 end = oldLine.endJoint.position;
			
			Joint startJoint = chateau.findJoint(Vector3.add(newBase, Vector3.subtract(start, oldBase)));
			Joint endJoint = chateau.findJoint(Vector3.add(newBase, Vector3.subtract(end, oldBase)));
			
			Line newLine = new Line(startJoint, endJoint);
			chateau.addLine(newLine);
		}
		
				
		chateau.switchPlane(chateau.ground);
		
		World suggestedWorld = new World(chateau);
		chateau.restoreWorld(originalWorld);
		
		return new Suggestion(suggestedWorld, "BlockCopy");
	}
	*/
}
