package ui;

import edu.cmu.cs.stage3.alice.scenegraph.*;
import edu.cmu.cs.stage3.math.*;

import java.awt.Graphics;
import java.awt.Point;
import java.util.*;


public class ChamferHelper extends Helper
{
	public Suggestion makeSuggestion(Chateau chateau){
		Object[] chain_set = get_chain(chateau.currentLines);
		
		if (chain_set == null)
			return null;
		

		Vector chain = (Vector) chain_set[0];
		Vector topJoints = (Vector) chain_set[1];

		Plate topPlate = find_common_plate(chain, chateau);
		if (topPlate == null)
			return null;
			
		for(int i=0; i<chain.size(); i++){
			Line line = (Line) chain.elementAt(i);
			if (topPlate.lines.contains(line))
				return null;
		}
		
		
		
		Joint joint0 = (Joint) topJoints.elementAt(0);
		Joint joint1 = (Joint) topJoints.elementAt(topJoints.size()-1);
		
		/*
		Joint joint0;
		Joint joint1;

		Line firstLine = (Line)chain.elementAt(0);
		Line lastLine = (Line)chain.elementAt(chain.size()-1);
		if (chain.size() == 1){
			joint0 = ((Line)chain.elementAt(0)).startJoint;
			joint1 = ((Line)chain.elementAt(0)).endJoint;
		}
		else {
			Line secondLine = (Line)chain.elementAt(1);
			Line secondLastLine = (Line)chain.elementAt(chain.size()-2);
			
			joint0 = firstLine.get_the_other_joint(firstLine.get_common_joint(secondLine));
			joint1 = lastLine.get_the_other_joint(lastLine.get_common_joint(secondLastLine));
		}
		*/
		
		Line firstLine = (Line)chain.elementAt(0);
		Line lastLine = (Line)chain.elementAt(chain.size()-1);

		Vector line0s = find_touched_line(topPlate.lines, joint0, firstLine);
		if (line0s.size() == 0)			return null;
		Vector line1s = find_touched_line(topPlate.lines, joint1, lastLine);
		if (line1s.size() == 0)			return null;
		
		
		
		
		Line line0=null;
		Line line1=null;
		for(int i=0; i<line0s.size(); i++){
			line0 = (Line) line0s.elementAt(i);
			for(int j=0; j<line1s.size(); j++){
				line1 = (Line) line1s.elementAt(j);
				if (line0 == line1)
					return make_gate(chain_set, topPlate, line0, chateau);
			}
		}

		Joint commonJoint = null;
		for(int i=0; i<line0s.size(); i++){
			line0 = (Line) line0s.elementAt(i);
			for(int j=0; j<line1s.size(); j++){
				line1 = (Line) line1s.elementAt(j);
				commonJoint = line0.get_common_joint(line1);
				if (commonJoint != null)	
					break;
			}
		}
		if (commonJoint == null)	return null;
		if (line0 == line1) return null;

		Plate side0 = get_side(line0, topPlate);
		if (side0 == null)			return null;
		Plate side1 = get_side(line1, topPlate);
		if (side1 == null)			return null;
		
		Line sideLine = side0.get_common_line(side1);
		if (sideLine == null)		return null;
		

		Joint bottomJoint = sideLine.get_the_other_joint(commonJoint);
		Line bottomLine0 = get_bottom_line(bottomJoint, sideLine, side0);
		Line bottomLine1 = get_bottom_line(bottomJoint, sideLine, side1);
		Plate bottomPlate = find_common_plate(bottomLine0, bottomLine1);
		if (bottomPlate == null) 	return null;
		
		Vector3 base = joint0.position;
		Vector3 normal = Vector3.crossProduct(Vector3.subtract(joint1.position, joint0.position), sideLine.getVector3());
		Plane cutPlane = new Plane(base, normal);
		
		Vector3 bottomPoint0 = cutPlane.get_cross_point(bottomLine0);
		if (bottomPoint0 == null) 	return null;
		
		Vector3 bottomPoint1 = cutPlane.get_cross_point(bottomLine1);
		if (bottomPoint1 == null) 	return null;
		
		Vector bottomInterimPoints = new Vector();
		Vector3 vec = sideLine.getVector3();
		for(int i=1; i<topJoints.size()-1; i++){
			Joint joint = (Joint) topJoints.elementAt(i);
			InfiniteLine lay = new InfiniteLine(joint.position, vec);
			Vector3 bottomPoint = bottomPlate.get_cross_point(lay);
			if (bottomPoint == null)
				return null;

			bottomInterimPoints.addElement(bottomPoint);
		}

		/*
		Vector topJoints = new Vector();
		topJoints.addElement(joint0);
		for(int i=0; i<chain.size()-1; i++){
			Line a = (Line)chain.elementAt(i);
			Line b = (Line)chain.elementAt(i+1);

			Joint joint = a.get_common_joint(b);
			topJoints.addElement(joint);
			InfiniteLine lay = new InfiniteLine(joint.position, vec);
			Vector3 bottomPoint = bottomPlate.get_cross_point(lay);
			if (bottomPoint == null)
				return null;

			bottomInterimPoints.addElement(bottomPoint);
		}
		topJoints.addElement(joint1);
		*/











		// let's make a suggestion!!	
		World originalWorld = 	new World(chateau);

		Joint bottomJoint0 = chateau.findJoint(bottomPoint0);
		Joint bottomJoint1 = chateau.findJoint(bottomPoint1);

		Vector bottomJoints = new Vector();
		bottomJoints.addElement(bottomJoint0);
		for(int i=0; i<bottomInterimPoints.size(); i++){
			Vector3 p = (Vector3) bottomInterimPoints.elementAt(i);
			bottomJoints.addElement(chateau.findJoint(p));
		}
		bottomJoints.addElement(bottomJoint1);
		
		Vector bottomChain = new Vector();		
		for(int i=0; i<chain.size(); i++){
			Joint j0 = (Joint) bottomJoints.elementAt(i);
			Joint j1 = (Joint) bottomJoints.elementAt(i+1);
			bottomChain.addElement(chateau.addLine(new Line(j0, j1)));
		}
		
		
		Line newLine0 = null;
		if (line0.get_the_other_joint(commonJoint) != joint0)
			newLine0 = chateau.addLine(new Line(line0.get_the_other_joint(commonJoint), joint0));
		Line newLine1 = null;
		if (line1.get_the_other_joint(commonJoint) != joint1)
			newLine1 = chateau.addLine(new Line(line1.get_the_other_joint(commonJoint), joint1));
		Vector topLines = Util.duplicateVector(topPlate.lines);
		topLines.removeElement(line0);
		topLines.removeElement(line1);
		//topLines.addElement(currentLine);
		for(int i=0; i<chain.size(); i++)
			topLines.addElement((Line)chain.elementAt(i));
		if (newLine0 != null)
			topLines.addElement(newLine0);
		if (newLine1 != null)
			topLines.addElement(newLine1);
		chateau.addPlate(new Plate(topLines));
		
		
		Line newBottomLine0 = null;
		if (bottomLine0.get_the_other_joint(bottomJoint) != bottomJoint0)
			newBottomLine0 = chateau.addLine(new Line(bottomLine0.get_the_other_joint(bottomJoint), bottomJoint0));
		Line newBottomLine1 = null;
		if (bottomLine1.get_the_other_joint(bottomJoint) != bottomJoint1)
			newBottomLine1 = chateau.addLine(new Line(bottomLine1.get_the_other_joint(bottomJoint), bottomJoint1));
		//Line newBottomLine = chateau.addLine(new Line(bottomJoint0, bottomJoint1));
		Vector bottomLines = Util.duplicateVector(bottomPlate.lines);
		bottomLines.removeElement(bottomLine0);
		bottomLines.removeElement(bottomLine1);
		if (newBottomLine0 != null)
			bottomLines.addElement(newBottomLine0);
		if (newBottomLine1 != null)
			bottomLines.addElement(newBottomLine1);
		for(int i=0; i<bottomChain.size(); i++)
			bottomLines.addElement((Line)bottomChain.elementAt(i));
		//bottomLines.addElement(newBottomLine);
		if (bottomLines.size() >=3)
			chateau.addPlate(new Plate(bottomLines));
		

		Line newSideLine0 = chateau.addLine(new Line(joint0, bottomJoint0));
		Vector sideLines0 = Util.duplicateVector(side0.lines);
		sideLines0.removeElement(line0);
		sideLines0.removeElement(sideLine);
		sideLines0.removeElement(bottomLine0);
		if (newLine0 != null)
			sideLines0.addElement(newLine0);
		sideLines0.addElement(newSideLine0);
		if (newBottomLine0 != null)
			sideLines0.addElement(newBottomLine0);
		if (sideLines0.size() >=3)
			chateau.addPlate(new Plate(sideLines0));
		Line newSideLine1 = chateau.addLine(new Line(joint1, bottomJoint1));
		Vector sideLines1 = Util.duplicateVector(side1.lines);
		sideLines1.removeElement(line1);
		sideLines1.removeElement(sideLine);
		sideLines1.removeElement(bottomLine1);
		if (newLine1 != null)
			sideLines1.addElement(newLine1);
		sideLines1.addElement(newSideLine1);
		if (newBottomLine1 != null)
			sideLines1.addElement(newBottomLine1);
		if (sideLines1.size() >=3)
			chateau.addPlate(new Plate(sideLines1));


		// side cover		
		//chateau.addPlate(new Plate(currentLine, newSideLine0, newBottomLine, newSideLine1));
		

		Vector newSideLines = new Vector();
//		newSideLines.addElement(newSideLine0);
		for(int i=0; i<chain.size()+1; i++){
			Joint j0 = (Joint) topJoints.elementAt(i);
			Joint j1 = (Joint) bottomJoints.elementAt(i);
			newSideLines.addElement(chateau.addLine(new Line(j0, j1)));	
		}
//		newSideLines.addElement(newSideLine1);

		for(int i=0; i<chain.size(); i++){
			Line l0 = (Line) chain.elementAt(i);
			Line l1 = (Line) bottomChain.elementAt(i);
			Line l2 = (Line) newSideLines.elementAt(i);
			Line l3 = (Line) newSideLines.elementAt(i+1);
			bottomChain.addElement(chateau.addPlate(new Plate(l0,l1,l2,l3)));
		}




		
		chateau.deletePlate(topPlate);
		chateau.deletePlate(side0);
		chateau.deletePlate(side1);
		chateau.deletePlate(bottomPlate);

		chateau.deleteLine(line0);
		chateau.deleteLine(line1);
		chateau.deleteLine(sideLine);
		chateau.deleteLine(bottomLine0);
		chateau.deleteLine(bottomLine1);
		
		
		
		//chateau.addCurrentLine(newSideLine0);
		//chateau.addCurrentLine(newSideLine1);
		for(int i=0; i<chain.size(); i++)
			chateau.addCurrentLine((Line) bottomChain.elementAt(i));
		for(int i=0; i<chain.size()+1; i++)
			chateau.addCurrentLine((Line) newSideLines.elementAt(i));

		Suggestion suggestion = new Suggestion(chateau, "Chamfer");
		chateau.restoreWorld(originalWorld);
		return suggestion;
		
	}
	public Vector find_touched_line(Vector lines, Joint joint, Line currentLine){
		Vector result = new Vector();
		for(int i=0; i<lines.size(); i++){
			Line line = (Line) lines.elementAt(i);
			if (line != currentLine && line.on_line_segment(joint.position))
				result.addElement(line);
		}
		return result;
	}
	
	public Plate find_common_plate(Line line0, Line line1){
		for(int i=0; i<line0.plates.size(); i++){
			Plate plate = (Plate) line0.plates.elementAt(i);
			if (line1.plates.contains(plate))
				return plate;
		}
		return null;
	}
	public Plate get_side(Line line, Plate plate){
		if (line.plates.size() != 2)
			return null;
		if (line.plates.elementAt(0) == plate)
			return (Plate) line.plates.elementAt(1);
		else
			return (Plate) line.plates.elementAt(0);
	}
	public Line get_bottom_line(Joint joint, Line baseLine, Plate plate){
		for(int i=0; i<joint.lines.size(); i++){
			Line line = (Line) joint.lines.elementAt(i);
			if (line != baseLine && plate.lines.contains(line))
				return line;
		}
		return null;
	}











	public Suggestion make_gate(Object[] chain_set, Plate topPlate, Line topLine, Chateau chateau){
		Vector chain = (Vector) chain_set[0];
		Vector topJoints = (Vector) chain_set[1];

		Joint joint0 = (Joint) topJoints.elementAt(0);
		Joint joint1 = (Joint) topJoints.elementAt(topJoints.size()-1);

		Joint topJoint0;
		Joint topJoint1;
		if (joint0.distance(topLine.startJoint) < joint0.distance(topLine.endJoint)){
			topJoint0 = topLine.startJoint;
			topJoint1 = topLine.endJoint;
		}
		else {
			topJoint0 = topLine.endJoint;
			topJoint1 = topLine.startJoint;
		}

		Plate sidePlate = get_side(topLine, topPlate);
		if (sidePlate == null)			return null;
		
		Line sideLine0 = sidePlate.findNextLine(topJoint0, topLine);
		if (sideLine0 == null) 			return null;
		Line sideLine1 = sidePlate.findNextLine(topJoint1, topLine);
		if (sideLine1 == null) 			return null;
		
		if (!sideLine0.parallel(sideLine1))
			return null;


		Joint bottomJoint0 = sideLine0.get_the_other_joint(topJoint0);
		Joint bottomJoint1 = sideLine1.get_the_other_joint(topJoint1);
		Line bottomLine = bottomJoint0.getCommonLine(bottomJoint1);
		if (bottomLine == null) 	return null;
		
		Plate bottomPlate = get_side(bottomLine, sidePlate);
		if (bottomPlate == null) 	return null;
		
		
		
		Vector3 sideVector = sideLine0.getVector3();	
		Vector3 topVector = topLine.getVector3();
		Vector3 tmpVector = Vector3.crossProduct(sideVector, topVector);
		Vector3 normal = Vector3.crossProduct(sideVector, tmpVector);
		Plane cutPlane0 = new Plane(joint0.position, normal);
		Plane cutPlane1 = new Plane(joint1.position, normal);
		
		Vector3 bottomPoint0 = cutPlane0.get_cross_point(bottomLine);
		if (bottomPoint0 == null) 	return null;
		Vector3 bottomPoint1 = cutPlane1.get_cross_point(bottomLine);
		if (bottomPoint1 == null) 	return null;
		
		Vector bottomInterimPoints = new Vector();
		Vector3 vec = sideVector;
		for(int i=1; i<topJoints.size()-1; i++){
			Joint joint = (Joint) topJoints.elementAt(i);
			InfiniteLine lay = new InfiniteLine(joint.position, vec);
			Vector3 bottomPoint = bottomPlate.get_cross_point(lay);
			if (bottomPoint == null)
				return null;

			bottomInterimPoints.addElement(bottomPoint);
		}












		// let's make a suggestion!!	
		World originalWorld = 	new World(chateau);

		Joint bottom_joint0 = chateau.findJoint(bottomPoint0);
		Joint bottom_joint1 = chateau.findJoint(bottomPoint1);

		Vector bottomJoints = new Vector();
		bottomJoints.addElement(bottom_joint0);
		for(int i=0; i<bottomInterimPoints.size(); i++){
			Vector3 p = (Vector3) bottomInterimPoints.elementAt(i);
			bottomJoints.addElement(chateau.findJoint(p));
		}
		bottomJoints.addElement(bottom_joint1);
		
		Vector bottomChain = new Vector();		
		for(int i=0; i<chain.size(); i++){
			Joint j0 = (Joint) bottomJoints.elementAt(i);
			Joint j1 = (Joint) bottomJoints.elementAt(i+1);
			bottomChain.addElement(chateau.addLine(new Line(j0, j1)));
		}
		
		
		Line newLine0 = null;
		if (joint0 != topJoint0)
			newLine0 = chateau.addLine(new Line(joint0, topJoint0));
		Line newLine1 = null;
		if (joint1 != topJoint1)
			newLine1 = chateau.addLine(new Line(joint1, topJoint1));
		Vector topLines = Util.duplicateVector(topPlate.lines);
		topLines.removeElement(topLine);
		for(int i=0; i<chain.size(); i++)
			topLines.addElement((Line)chain.elementAt(i));
		if (newLine0 != null)
			topLines.addElement(newLine0);
		if (newLine1 != null)
			topLines.addElement(newLine1);
		chateau.addPlate(new Plate(topLines));
		
		
		Line newBottomLine0 = null;
		if (bottom_joint0 != bottomJoint0)
			newBottomLine0 = chateau.addLine(new Line(bottom_joint0, bottomJoint0));
		Line newBottomLine1 = null;
		if (bottom_joint1 != bottomJoint1)
			newBottomLine1 = chateau.addLine(new Line(bottom_joint1, bottomJoint1));
		Vector bottomLines = Util.duplicateVector(bottomPlate.lines);
		bottomLines.removeElement(bottomLine);
		if (newBottomLine0 != null)
			bottomLines.addElement(newBottomLine0);
		if (newBottomLine1 != null)
			bottomLines.addElement(newBottomLine1);
		for(int i=0; i<bottomChain.size(); i++)
			bottomLines.addElement((Line)bottomChain.elementAt(i));
		if (bottomLines.size() >=3)
			chateau.addPlate(new Plate(bottomLines));
		

		Line newSideLine0 = chateau.addLine(new Line(joint0, bottom_joint0));
		Vector sideLines0 = Util.duplicateVector(sidePlate.lines);
		sideLines0.removeElement(topLine);
		sideLines0.removeElement(sideLine1);
		sideLines0.removeElement(bottomLine);
		if (newLine0 != null)
			sideLines0.addElement(newLine0);
		sideLines0.addElement(newSideLine0);
		if (newBottomLine0 != null)
			sideLines0.addElement(newBottomLine0);
		if (sideLines0.size() >=3)
			chateau.addPlate(new Plate(sideLines0));

		Line newSideLine1 = chateau.addLine(new Line(joint1, bottom_joint1));
		Vector sideLines1 = Util.duplicateVector(sidePlate.lines);
		sideLines1.removeElement(topLine);
		sideLines1.removeElement(sideLine0);
		sideLines1.removeElement(bottomLine);
		if (newLine1 != null)
			sideLines1.addElement(newLine1);
		sideLines1.addElement(newSideLine1);
		if (newBottomLine1 != null)
			sideLines1.addElement(newBottomLine1);
		if (sideLines1.size() >=3)
			chateau.addPlate(new Plate(sideLines1));


		// side cover		
		Vector newSideLines = new Vector();
		for(int i=0; i<chain.size()+1; i++){
			Joint j0 = (Joint) topJoints.elementAt(i);
			Joint j1 = (Joint) bottomJoints.elementAt(i);
			newSideLines.addElement(chateau.addLine(new Line(j0, j1)));	
		}

		for(int i=0; i<chain.size(); i++){
			Line l0 = (Line) chain.elementAt(i);
			Line l1 = (Line) bottomChain.elementAt(i);
			Line l2 = (Line) newSideLines.elementAt(i);
			Line l3 = (Line) newSideLines.elementAt(i+1);
			bottomChain.addElement(chateau.addPlate(new Plate(l0,l1,l2,l3)));
		}




		
		chateau.deletePlate(topPlate);
		chateau.deletePlate(sidePlate);
		chateau.deletePlate(bottomPlate);

		chateau.deleteLine(topLine);
		chateau.deleteLine(bottomLine);
		
		for(int i=0; i<chain.size(); i++)
			chateau.addCurrentLine((Line) bottomChain.elementAt(i));
		for(int i=0; i<chain.size()+1; i++)
			chateau.addCurrentLine((Line) newSideLines.elementAt(i));

		Suggestion suggestion = new Suggestion(chateau, "Chamfer");
		chateau.restoreWorld(originalWorld);
		return suggestion;
		


	}	

}
