package ui;

import edu.cmu.cs.stage3.alice.scenegraph.*;
import edu.cmu.cs.stage3.math.*;

import java.awt.Graphics;
import java.awt.Point;
import java.util.*;


public class DrawBoxHelper extends PlaneHelper
{
	public Suggestion makeSuggestion(Chateau chateau){
		if (chateau.currentLines.size() != 3) 
			return null;
		
		Line line0 = (Line) chateau.currentLines.elementAt(0);	
		Line line1 = (Line) chateau.currentLines.elementAt(1);	
		Line line2 = (Line) chateau.currentLines.elementAt(2);	
	
		Joint baseJoint = line0.get_common_joint(line1);
		if (baseJoint == null || baseJoint != line0.get_common_joint(line2))
			return null;
		
		//Vector3 cross0 = Vector3.crossProduct(line0.getVector3(), line1.getVector3());
		//Vector3 cross1 = Vector3.crossProduct(line0.getVector3(), line2.getVector3());
		//if (Line.parallel(cross0, cross1))
		//	return null;
			
		Plane basePlane = find_common_plane(chateau.currentLines);
		if (basePlane!=null)
			return null;




		// let's make a suggestion!!	
		World originalWorld = 	new World(chateau);
	
		Joint joint0 = line0.get_the_other_joint(baseJoint);
		Joint joint1 = line1.get_the_other_joint(baseJoint);
		Joint joint2 = line2.get_the_other_joint(baseJoint);
		
		Vector3 v0 = Vector3.subtract(joint0.position, baseJoint.position);
		Vector3 v1 = Vector3.subtract(joint1.position, baseJoint.position);
		Vector3 v2 = Vector3.subtract(joint2.position, baseJoint.position);
		
		Joint joint01 = chateau.findJoint(Vector3.add(joint0.position, v1));
		Joint joint02 = chateau.findJoint(Vector3.add(joint0.position, v2));
		Joint joint12 = chateau.findJoint(Vector3.add(joint1.position, v2));		
		Joint joint012 = chateau.findJoint(Vector3.add(joint01.position, v2));		
		
		Line line_0_01 = chateau.addLine(new Line(joint0, joint01));
		Line line_1_01 = chateau.addLine(new Line(joint1, joint01));
		Line line_0_02 = chateau.addLine(new Line(joint0, joint02));
		Line line_01_012 = chateau.addLine(new Line(joint01, joint012));
		Line line_1_12 = chateau.addLine(new Line(joint1, joint12));
		Line line_2_02 = chateau.addLine(new Line(joint2, joint02));
		Line line_2_12 = chateau.addLine(new Line(joint2, joint12));
		Line line_02_012 = chateau.addLine(new Line(joint02, joint012));
		Line line_12_012 = chateau.addLine(new Line(joint12, joint012));
		
		chateau.addPlate(new Plate(line0, line_0_01, line_1_01, line1));
		chateau.addPlate(new Plate(line0, line_0_02, line_2_02, line2));
		chateau.addPlate(new Plate(line_0_01, line_01_012, line_02_012, line_0_02));
		chateau.addPlate(new Plate(line_1_01, line_01_012, line_12_012, line_1_12));
		chateau.addPlate(new Plate(line1, line_1_12, line_2_12, line2));
		chateau.addPlate(new Plate(line_2_02, line_02_012, line_12_012, line_2_12));

		chateau.addCurrentLine(line_0_01);
		chateau.addCurrentLine(line_1_01);
		chateau.addCurrentLine(line_0_02);
		chateau.addCurrentLine(line_01_012);
		chateau.addCurrentLine(line_1_12);
		chateau.addCurrentLine(line_2_02);
		chateau.addCurrentLine(line_2_12);
		chateau.addCurrentLine(line_02_012);
		chateau.addCurrentLine(line_12_012);
		
		Suggestion suggestion = new Suggestion(chateau, "DrawBox");
		chateau.restoreWorld(originalWorld);
		return suggestion;
		
	}
	
}
