package ui;

import edu.cmu.cs.stage3.alice.scenegraph.*;
import edu.cmu.cs.stage3.math.*;

import java.awt.Graphics;
import java.awt.Point;
import java.util.*;


public class DrawRectHelper extends Helper
{
	public Suggestion makeSuggestion(Chateau chateau){
	
		/*
			
		Line currentLine = chateau.currentLine();
		Plane currentPlane = chateau.currentPlane;
		
		if (currentLine == null || !currentPlane.contains(currentLine))
			return null;
	
		Joint commonJoint = null;
		if (currentLine.startJoint.lines.size() == 1 &&
			currentLine.endJoint.lines.size() >= 2) 
			commonJoint = currentLine.endJoint;
		else if (currentLine.startJoint.lines.size() >= 2 &&
			currentLine.endJoint.lines.size() == 1) 
			commonJoint = currentLine.startJoint;
		else
			return null;
			
		Line secondLine = null;
		for(int i=0; i<commonJoint.lines.size(); i++){
			Line line = (Line) commonJoint.lines.elementAt(i);
			if (line != currentLine && currentPlane.contains(line)){
				secondLine = line;
				break;
			}
		}
		if (secondLine == null)
			return null;
		*/
		
		if (chateau.currentLines.size() != 2) 
			return null;

		Line currentLine = (Line) chateau.currentLines.elementAt(1);	
		Line secondLine = (Line) chateau.currentLines.elementAt(0);	
			
		if (!currentLine.perpendicular(secondLine))	//currentLine.parallel(secondLine))
			return null;
		Joint commonJoint = currentLine.get_common_joint(secondLine);
		if (commonJoint == null)
			return null;
		
		
		Joint joint0 = currentLine.get_the_other_joint(commonJoint);
		Joint joint1 = secondLine.get_the_other_joint(commonJoint);
		//if (num_of_lines_on_plane(joint1, currentPlane) > 1)
		//	return null;
			
		//Plane currentPlane = chateau.getPlane(currentLine.get_common_plane(secondLine));
		
		
		
			
		// let's make a suggestion!!	
		World originalWorld = 	new World(chateau);
		
		Vector3 vec0 = Vector3.subtract(joint0.position, commonJoint.position);
		Vector3 vec1 = Vector3.subtract(joint1.position, commonJoint.position);
		
		Vector3 new_corner = Vector3.add(commonJoint.position, Vector3.add(vec0, vec1));
		
		Joint newJoint = chateau.findJoint(new_corner);
			
		Line newLine0 = new Line(joint0, newJoint);
		Line newLine1 = new Line(joint1, newJoint);	
		newLine0 = chateau.addLine(newLine0);
		newLine1 = chateau.addLine(newLine1);

		chateau.addPlate(new Plate(currentLine, secondLine, newLine0, newLine1));
		
		//newLine0.addParentPlane(currentPlane);
		//newLine1.addParentPlane(currentPlane);
		
		//chateau.switchPlane(currentPlane);
		

		chateau.clearCurrentLines();		
		chateau.addCurrentLine(secondLine);
		chateau.addCurrentLine(newLine0);
		chateau.addCurrentLine(newLine1);
		chateau.addCurrentLine(currentLine);
		
		Suggestion suggestion = new Suggestion(chateau, "Rectangle");
		chateau.restoreWorld(originalWorld);
		return suggestion;
	}
	
	public int num_of_lines_on_plane(Joint joint, Plane plane){
		int n = 0;
		for(int i=0; i<joint.lines.size(); i++){
			Line line = (Line) joint.lines.elementAt(i);
			if (plane.contains(line))
				n++;
		}
		return n;
	}

}
