package ui;

import edu.cmu.cs.stage3.alice.scenegraph.*;
import edu.cmu.cs.stage3.math.*;

import java.awt.Graphics;
import java.awt.Point;
import java.util.*;


public class ExtrudeHelper extends Helper
{
	public Suggestion makeSuggestion(Chateau chateau){
		if (chateau.currentLines.size() <= 1)
			return null;
			
		if (!all_connected(chateau.currentLines))
			return null;

		Line currentLine = chateau.currentLine();
		Plane currentPlane = chateau.currentPlane;
		
		Joint commonJoint = null;
		Joint topJoint = null;
	
		Vector baseLines = Util.duplicateVector(chateau.currentLines);
		baseLines.removeElement(currentLine);
		Plane basePlane = find_common_plane(baseLines);

		if (basePlane!=null && basePlane.contains(currentLine))
			return null;
			
		if (basePlane==null){ 
			for(int i=0; i<chateau.currentLines.size()-1; i++){
				currentLine = (Line) chateau.currentLines.elementAt(i);
				baseLines = Util.duplicateVector(chateau.currentLines);
				baseLines.removeElement(currentLine);
				basePlane = find_common_plane(baseLines);
				if (basePlane != null)
					break;
			}
			if (basePlane == null)
				return null;
		}
			
		if (basePlane.contains(currentLine.startJoint.position)){
			commonJoint = currentLine.startJoint;
			topJoint = currentLine.endJoint;
		}
		else if (basePlane.contains(currentLine.endJoint.position)){
			commonJoint = currentLine.endJoint;
			topJoint = currentLine.startJoint;
		}
		else
			return null;
			



		
		// let's make a suggestion!!	
		World originalWorld = 	new World(chateau);
		
		//chateau.clearCurrentLines();
		
		//Plane topPlane = new Plane(topJoint.position, basePlane.normal);
		//topPlane = chateau.getPlane(topPlane);

		Vector3 vec = Vector3.subtract(topJoint.position, commonJoint.position);		
		
		Vector topLines = new Vector();
		for(int i=0; i<baseLines.size(); i++){
			Line line = (Line) baseLines.elementAt(i);
			Joint elevated_startJoint = chateau.findJoint(Vector3.add(line.start, vec));
			Joint elevated_endJoint = chateau.findJoint(Vector3.add(line.end, vec));
		
			Line line0 = chateau.addLine(new Line(line.startJoint, elevated_startJoint));
			Line line1 = chateau.addLine(new Line(line.endJoint, elevated_endJoint));
			Line topLine = chateau.addLine(new Line(elevated_startJoint, elevated_endJoint));
			
			chateau.addCurrentLine(line0);
			chateau.addCurrentLine(line1);
			chateau.addCurrentLine(topLine);
			//topLine.addParentPlane(topPlane);
			
			topLines.addElement(topLine);
			chateau.addPlate(new Plate(line, line0, topLine, line1));
		}
		
		if (is_loop(baseLines)){
			chateau.addPlate(new Plate(baseLines));
			chateau.addPlate(new Plate(topLines));
		}
				
		//chateau.switchPlane(topPlane);

		Suggestion suggestion = new Suggestion(chateau, "Extrusion");
		chateau.restoreWorld(originalWorld);
		return suggestion;
		
	}
	
	
}
