package ui;

import java.awt.event.*;
import java.awt.*;
import java.applet.*;

import java.lang.*;
import java.util.*;
import java.io.*;



class FileHandler {


  public static Vector[] load(String filename){
  
    Vector joints = new Vector();	
	Vector lines = new Vector();
    Vector plates = new Vector();

    // read vertices and faces from file...
    //System.out.println("hello a");

    try{
    BufferedReader in = new BufferedReader(new FileReader(filename)); 
	while (true){
	  String line = in.readLine();
	  if (line == null) break;
	   // System.out.println("hello b "+ line);	  
	   StringTokenizer st = new StringTokenizer(line);
	   if (st. hasMoreTokens()){

	     String head = st.nextToken();
	     if (head.equals("j")){
	     	double x = (new Double(st.nextToken())).doubleValue();
	     	double y = (new Double(st.nextToken())).doubleValue();
	     	double z = (new Double(st.nextToken())).doubleValue();
	     	double[] joint = {x,y,z};
	        joints.addElement(joint);
	     }
	     else if (head.equals("l")){
		    int start = (new Integer(st.nextToken())).intValue();
		    int end = (new Integer(st.nextToken())).intValue();
		    int[] l = {start, end};
			lines.addElement(l);
	     }
	     else if (head.equals("p")){
			Vector v = new Vector();
			while(st.hasMoreTokens()){
			    int index = (new Integer(st.nextToken())).intValue();
		    	v.addElement(new Integer(index));
			}
			plates.addElement(v);
	     }

		    //System.out.println("hello c "+ head);	  
	
	   }
	}
	in.close();
    //System.out.println("hello d ");	  

    }
    catch(IOException e) { System.out.print("IO Error "+e);}

  
    //return new World(joints, lines, plates);
    Vector[] vectors = {joints, lines, plates};
    return vectors;

  }





  public static void save(World world, String filename){

	for(int i=0; i<world.joints.size(); i++){
		Joint joint = (Joint) world.joints.elementAt(i);
		joint.index = i;
	}
	for(int i=0; i<world.lines.size(); i++){
		Line line = (Line) world.lines.elementAt(i);
		line.index = i;
	}
	for(int i=0; i<world.plates.size(); i++){
		Plate plate = (Plate) world.plates.elementAt(i);
		plate.index = i;
	}
	

    try{
		BufferedWriter out   = new BufferedWriter(new FileWriter(filename)); 
		for(int i=0; i<world.joints.size(); i++){
		    Joint j = (Joint) world.joints.elementAt(i);
			String line = "j "+ j.position.x + " " + j.position.y + " " + j.position.z; 
			out.write(line);
			out.newLine();
		}

		for(int i=0; i<world.lines.size(); i++){
			Line line = (Line) world.lines.elementAt(i);
			String string = "l "+line.startJoint.index + " " + line.endJoint.index;
		    out.write(string);
		    out.newLine();
		}	

		for(int i=0; i<world.plates.size(); i++){
			Plate plate = (Plate) world.plates.elementAt(i);
			String string = "p";
			for(int j=0; j<plate.lines.size(); j++){
				Line line = (Line) plate.lines.elementAt(j);
				string += " " + line.index;
			}
		    out.write(string);
		    out.newLine();
		}	

		out.flush();
		out.close();

    }
    catch(IOException e) { System.out.print("IO Error "+e);}

  }

}

