package ui;

import edu.cmu.cs.stage3.alice.scenegraph.*;
import edu.cmu.cs.stage3.math.*;

import java.awt.Graphics;
import java.awt.Point;
import java.util.*;


public class FlipCopyHelper extends Helper
{
	public Suggestion makeSuggestion(Chateau chateau){
	
		if (chateau.currentLines.size() <= 3)
			return null;
			
		Line currentLine = chateau.currentLine();
		Line prevLine = (Line) chateau.currentLines.elementAt(chateau.currentLines.size()-2);
		
		Vector lines = Util.duplicateVector(chateau.currentLines);
		lines.removeElement(currentLine);
		
		Vector connected1 = prevLine.gatherConnectedLines(lines);
		if (lines.size() != connected1.size())
			return null;
		
		
		if (Math.abs(currentLine.getLength() - prevLine.getLength()) > Chateau.ERROR)
			return null;
		if (currentLine.parallel(prevLine))
			return null;
		
		Vector3 oldBase,newBase;

		if (currentLine.startJoint == prevLine.startJoint){
			oldBase = prevLine.end;
			newBase = currentLine.end;
		}
		else if (currentLine.startJoint == prevLine.endJoint){
			oldBase = prevLine.start;
			newBase = currentLine.end;
		}
		else if (currentLine.endJoint == prevLine.endJoint){
			oldBase = prevLine.start;
			newBase = currentLine.start;
		}
		else if (currentLine.endJoint == prevLine.startJoint){
			oldBase = prevLine.end;
			newBase = currentLine.start;
		}
		else {
			Vector3 start_to_start = Vector3.subtract(currentLine.start, prevLine.start);
			Vector3 end_to_end = Vector3.subtract(currentLine.end, prevLine.end);
			if (Line.parallel(start_to_start, end_to_end)){
				oldBase = prevLine.start;
				newBase = currentLine.start;
			}
			else {
				Vector3 start_to_end = Vector3.subtract(currentLine.end, prevLine.start);
				Vector3 end_to_start = Vector3.subtract(currentLine.start, prevLine.end);
				if (Line.parallel(start_to_end, end_to_start)){
					oldBase = prevLine.start;
					newBase = currentLine.end;
				}
				else
					return null;
			}
		}
		
		
		Vector3 normal = Vector3.normalizeV(Vector3.subtract(newBase, oldBase));
		Vector3 base = Line.midPoint(oldBase, newBase);
		






		// let's make a suggestion!!	
		World originalWorld = 	new World(chateau);

		
		//Vector lines = new Vector();
		//for(int i=0; i<chateau.currentLines.size()-1; i++)
		//	lines.addElement(chateau.currentLines.elementAt(i));
		
		Vector plates = new Vector();
		Hashtable hash = new Hashtable();
		
		for(int i=0; i<lines.size(); i++){
			Line oldLine = (Line) lines.elementAt(i);
			Vector3 start = oldLine.startJoint.position;
			Vector3 end = oldLine.endJoint.position;
			
			Joint startJoint = chateau.findJoint(flip(start, base, normal));
			Joint endJoint = chateau.findJoint(flip(end, base, normal));
			
			Line newLine = new Line(startJoint, endJoint);
			Line line0 = chateau.addLine(newLine);
			
			chateau.addCurrentLine(line0);
			
			hash.put(oldLine, line0);
			for(int j=0; j<oldLine.plates.size(); j++){
				Plate plate = (Plate) oldLine.plates.elementAt(j);
				if (!plates.contains(plate))
					plates.addElement(plate);
			}
		}
		
		for(int i=0; i<plates.size(); i++){
			Plate plate = (Plate) plates.elementAt(i);
			Vector newLines = new Vector();
			for(int j=0; j<plate.lines.size(); j++){
				Line oldLine = (Line) plate.lines.elementAt(j);
				Line newLine = (Line) hash.get(oldLine);
				if (newLine == null){
					newLines = null;
					break;
				}
				newLines.addElement(newLine);
			}
			if (newLines != null)
				chateau.addPlate(new Plate(newLines));
		}
		
		
		chateau.addCurrentLine(prevLine);
		chateau.addCurrentLine(currentLine);
				
		chateau.switchPlane(chateau.ground);

		Suggestion suggestion = new Suggestion(chateau, "FlipCopy");
		chateau.restoreWorld(originalWorld);
		return suggestion;
	}





	
	public Vector3 flip(Vector3 v, Vector3 base, Vector3 normal){
		Vector3 dv = Vector3.subtract(v, base);
		Vector3 dv_n = Vector3.multiply(normal, Vector3.dotProduct(normal, dv));
		Vector3 dv_m = Vector3.subtract(dv, dv_n);
		
		Vector3 new_dv_n = Vector3.multiply(dv_n, -1);
		Vector3 new_dv = Vector3.add(dv_m, new_dv_n);
		Vector3 new_v = Vector3.add(base, new_dv);
		
		return new_v;
	}			




}
