package ui;

import edu.cmu.cs.stage3.alice.scenegraph.*;
import edu.cmu.cs.stage3.math.*;

import java.awt.Graphics;
import java.awt.Point;
import java.util.*;

public class InfiniteLine
{
	Vector3 base;
	Vector3 direction;
	InfiniteLine(Vector3 b, Vector3 d){
		base = b;
		direction = Vector3.multiply(d,1/d.getLength());
	}
	InfiniteLine(Line line){
		base = line.start;
		direction = line.getNormal();
	}
	public boolean equivalent(InfiniteLine line){
		// parallel
		if (Vector3.crossProduct(direction, line.direction).getLength()>Chateau.ERROR)
			return false;
		if (getDistance(line.base)>Chateau.ERROR)
			return false;
		return true;
	}
	
	public double getDistance(Vector3 p){
		Vector3 baseToP = Vector3.subtract(p, base);
		Vector3 vec = direction;

		double bunbo = vec.getLength();
		double bunshi = Vector3.crossProduct(vec, baseToP).getLength();

		if ( bunbo == 0 ) {
			System.out.println("Error in Line.getDistance()");
	       	return 0;
	    }
	  	else {
	       return Math.abs(bunshi / bunbo);
	  	}
			
	}
	public Vector3 getClosestPoint(Vector3 p){
		Vector3 vec = direction;
		double t = Vector3.dotProduct(Vector3.subtract(p, base), vec)/Vector3.dotProduct(vec, vec);
		return Vector3.add(base, Vector3.multiply(vec, t));
	}	
	public Vector3 crossPoint(InfiniteLine line){
		return crossPoint(line.base, line.direction);
	}
	public Vector3 crossPoint(Line line){
		Vector3 vec = line.getVector3();
		return crossPoint(line.start, vec);
	}
	public Vector3 crossPoint(Vector3 p, Vector3 vec){
		Vector3 n = Vector3.crossProduct(direction, vec);
		Vector3 normal = Vector3.crossProduct(direction, n);
		
		Vector3 p_to_base = Vector3.subtract(base, p);
		double t = Vector3.dotProduct(normal, p_to_base)/Vector3.dotProduct(normal, vec);
		
		return Vector3.add(p, Vector3.multiply(vec, t));
	}
		
}