package ui;

import edu.cmu.cs.stage3.alice.scenegraph.*;
import edu.cmu.cs.stage3.math.*;

public class JaliceFrame extends java.awt.Frame 
	implements java.awt.event.WindowListener, 
		edu.cmu.cs.stage3.alice.scenegraph.renderer.event.OnscreenRenderTargetListener,
		edu.cmu.cs.stage3.alice.scenegraph.renderer.event.RendererListener {


	public final Color BACKGROUND_COLOR = Def.BACKGROUND_COLOR;	//new Color(0.55,0.71,1);
	
	public final double  V_ANGLE = Math.PI/4;
//    public edu.cmu.cs.stage3.alice.scenegraph.renderer.RendererInfo rendererInfo;
//    public edu.cmu.cs.stage3.alice.scenegraph.renderer.RenderTarget renderTarget;
	public edu.cmu.cs.stage3.alice.scenegraph.renderer.RendererInfo rendererInfo;
	public edu.cmu.cs.stage3.alice.scenegraph.renderer.OnscreenRenderTarget renderTarget;
  
	public java.awt.event.MouseListener mouseListener;
	public java.awt.event.MouseMotionListener mouseMotionListener;

	public Chateau target;
	public JaliceFrame(edu.cmu.cs.stage3.alice.scenegraph.renderer.RendererInfo rendererInfo, Chateau target){
        super();

        this.rendererInfo = rendererInfo;
		//this.mouseListener = (java.awt.event.MouseListener) target;
		//this.mouseMotionListener = (java.awt.event.MouseMotionListener) target;

		this.target = target;
		target.jaliceFrame = this;


		setTitle( "Chateau");//getClass().getName() );
		addWindowListener( this );
		//addComponentListener( this );
		setLayout( new java.awt.BorderLayout() );
        setSize( new java.awt.Dimension(640,640));
        show();
	}



    public Scene scene;
    public Transformable cameraVehicle;
    public  Transformable sunVehicle;
    public Visual groundVisual;
    public Color pickedColor = null;
    public Visual pickedVisual = null;
    public double prevTime = System.currentTimeMillis();

    public void loadITA( IndexedTriangleArray ita, String dirname ) {
        try {
            java.io.InputStream is;
            is = new java.io.FileInputStream( dirname+"/vertices.bin" );
            ita.loadVertices( is );
            is.close();
            is = new java.io.FileInputStream( dirname+"/indices.bin" );
            ita.loadIndices( is );
            is.close();
        } catch( java.io.FileNotFoundException fnfe ) {
            fnfe.printStackTrace();
        } catch( java.io.IOException ioe ) {
            ioe.printStackTrace();
        }
    }


    public Camera initSceneGraph() {
		scene = new Scene();

        cameraVehicle = new Transformable();
        cameraVehicle.setParent( scene );
        SymmetricPerspectiveCamera camera = new SymmetricPerspectiveCamera();
		camera.setVerticalViewingAngle( V_ANGLE );
		
		camera.setParent( cameraVehicle );

        Background background = new Background();
        background.setColor(BACKGROUND_COLOR);// Color.PURPLE );//Color.WHITE);//
        scene.setBackground( background );

		
        AmbientLight ambientLight = new AmbientLight();
        ambientLight.setParent( scene );
        //ambientLight.setColor( new Color(208.0/255, 139.0/255, 97.0/255));//new Color( 0.2, 0.2, 0.2 ) );
		ambientLight.setColor( Def.AMBIENT_COLOR);//new Color( 0.8,0.8,0.8));//0.5, 0.5, 0.5 ) );
		
        sunVehicle = new Transformable();
        sunVehicle.setParent( scene );
        DirectionalLight sunLight = new DirectionalLight();
        //sunLight.setColor(new Color(254.0/255, 235.0/255, 221.0/255));//WHITE );
        sunLight.setColor(Def.SUN_COLOR);//Color.WHITE );
        sunLight.setParent( sunVehicle );
        sunVehicle.setOrientation( new Vector3( -1, -0.9, 0.8 ), Vector3.Y_AXIS, null );

		init_camera_position();

		return camera;
    }
	public void init_camera_position(){
        cameraVehicle.setPosition( new Vector3(1.5, 0.7, 3.28), null);// 0, 0, -4 ), null );
        //cameraVehicle.pointAt( scene, Vector3.Y_AXIS, scene );
       	cameraVehicle.setOrientation(new Vector3(-0.41, -0.31, -0.85), new Vector3(-0.14, 0.95, -0.28), scene);
		
		update_light_position();

	}
	public void update_light_position(){
		//Vector3 camera_to_scene = Vector3.multiply(cameraVehicle.getPosition(null), -1);
		//sunVehicle.setOrientation(camera_to_scene, Vector3.Y_AXIS, null );
		
		Matrix33 axes = cameraVehicle.getAxes( scene );
		Vector3 forward = axes.getRow( 2 );
		sunVehicle.setOrientation(forward, Vector3.Y_AXIS, null );
	}





	







	Transformable dammy = new Transformable();
	public Vector3 get_local_coords(Vector3 v, Transformable parent){
		
		//Transformable dammy = new Transformable();
		dammy.setParent(scene);
		dammy.setPosition(v, scene);
		Vector3 w = dammy.getPosition(parent);
		dammy.setParent(null);
		return w;
	}



	public Vector3 get_scene_coords(Vector3 v, Transformable parent){
		//Transformable dammy = new Transformable();
		dammy.setParent(parent);
		dammy.setPosition(v, parent);
		Vector3 w = dammy.getPosition(scene);
		dammy.setParent(null);
		return w;
	}
	/*
	public Vector3 screen_coords_to_scene_coords(java.awt.Point p){
		Vector4 viewportPt = new Vector4(p.x, p.y, 0.97, 1);
		return (renderTarget).transformFromViewport(
						viewportPt, camera, (ReferenceFrame)scene );
	}
	public Vector3 local_coords_to_screen_coords(Vector3 localPt, ReferenceFrame  targetVehicle){
		Vector4 v = (renderTarget).transformToViewport(
					localPt, targetVehicle, camera );
		return new Vector3(v.x/v.w, v.y/v.w, v.z/v.w);
	}
	public Vector3 scene_coords_to_screen_coords(Vector3 localPt){
		Vector4 v = (renderTarget).transformToViewport(
					localPt, scene, camera );
		return new Vector3(v.x/v.w, v.y/v.w, v.z/v.w);
	}
	*/

	public Vector3 local_coords_to_screen_coords(Vector3 localPt, ReferenceFrame  targetVehicle){

		Vector3 cameraPt = targetVehicle.transformTo(localPt, cameraVehicle);
		return new Vector3(renderTarget.transformFromCameraToViewport(cameraPt, camera));
	}
	
//	public Vector3 local_coords_to_screen_coords(Vector3 localPt, ReferenceFrame  targetVehicle){
//
//		Vector3 cameraPt = targetVehicle.transformTo(localPt, cameraVehicle);
//		return renderTarget.transformFromCameraToViewport(cameraPt, camera);
//	}
	public Vector3 scene_coords_to_screen_coords(Vector3 localPt){
		return local_coords_to_screen_coords(localPt, scene);
	}

	
	public Vector3 screen_coords_to_scene_coords(java.awt.Point p){
		return screen_coords_to_local_coords(p.x, p.y, scene);
	}
	public Vector3 screen_coords_to_local_coords(java.awt.Point p, ReferenceFrame reference){
		return screen_coords_to_local_coords(p.x, p.y, reference);
	}
	public Vector3 screen_coords_to_local_coords(double x, double y, ReferenceFrame reference){
		if (reference == null)
			reference = scene;
		Vector3 viewportPt = new Vector3(x, y, 0.97);
		Vector3 cameraPt = new Vector3(renderTarget.transformFromViewportToCamera(viewportPt, camera));
		return cameraVehicle.transformTo(cameraPt, reference);

	}
	public InfiniteLine get_camera_lay(java.awt.Point p){
		Vector3 v = screen_coords_to_scene_coords(p);
		Vector3 c = cameraVehicle.getPosition(scene);
		return new InfiniteLine(c, Vector3.subtract(v,c));
		
	}
	

	public Vector3 screen_coords_to_local_coords(java.awt.Point p, Visual targetVisual, Transformable targetVehicle){
		edu.cmu.cs.stage3.alice.scenegraph.renderer.PickInfo pickInfo = Chateau.jaliceFrame.renderTarget.pick( p.x, p.y, false, false);
        Visual[] visuals = pickInfo.getVisuals();
		
		
		if( visuals != null && visuals.length>0){// && visuals[0] == Chateau.jaliceFrame.canvas.canvasVisual) {

			
			int n=0;
			while(visuals[n] != targetVisual)
				n++;

			Vector3 localPt = new Vector3(pickInfo.getLocalPosition(n));
			return localPt;
			
		}
		return null;
	}
	public Vector3 screen_coords_to_scene_coords(java.awt.Point p, Visual targetVisual, Transformable targetVehicle){
	
		edu.cmu.cs.stage3.alice.scenegraph.renderer.PickInfo pickInfo = Chateau.jaliceFrame.renderTarget.pick( p.x, p.y, false, false);
        Visual[] visuals = pickInfo.getVisuals();
		
		if( visuals != null && visuals.length>0){// && visuals[0] == Chateau.jaliceFrame.canvas.canvasVisual) {
		
			int n=0;
			while(visuals[n] != targetVisual)
				n++;
	
			Vector3 localPt = new Vector3(pickInfo.getLocalPosition(n));
			return get_scene_coords(localPt, (Transformable) targetVisual.getParent());
			

		}
		return null;
	}
	public double get_pick_depth(java.awt.Point p, Visual targetVisual){
	
		edu.cmu.cs.stage3.alice.scenegraph.renderer.PickInfo pickInfo = Chateau.jaliceFrame.renderTarget.pick( p.x, p.y, false, false);
        Visual[] visuals = pickInfo.getVisuals();
		
		if( visuals != null && visuals.length>0){// && visuals[0] == Chateau.jaliceFrame.canvas.canvasVisual) {
		
			int n=0;
			while(visuals[n] != targetVisual)
				n++;
			Vector3 localPt = new Vector3(pickInfo.getLocalPosition(n));
			Vector3 scenePt = get_scene_coords(localPt, (Transformable) targetVisual.getParent());
			return Vector3.subtract(scenePt, cameraVehicle.getPosition(scene)).getLength();
			

		}
		return 0;
	}

	
	public Visual pickVisual(java.awt.Point p, java.util.Vector targetVisuals){
		edu.cmu.cs.stage3.alice.scenegraph.renderer.PickInfo pickInfo = Chateau.jaliceFrame.renderTarget.pick( p.x, p.y, false, false);
		
		if (pickInfo == null)
			return null;
			
        Visual[] pickedVisuals = pickInfo.getVisuals();
		//System.out.println("pickVisual "+pickedVisuals.length);
		
		if( pickedVisuals != null && pickedVisuals.length>0){

			for(int i=0; i<pickedVisuals.length; i++)
				for(int j=0; j<targetVisuals.size(); j++)
					if (pickedVisuals[i] == targetVisuals.elementAt(j))
						return pickedVisuals[i];
				
			return null;
		}
		return null;
	}
	
	
	






    public void windowActivated( java.awt.event.WindowEvent windowEvent ) {
    }
    public void windowClosed( java.awt.event.WindowEvent windowEvent ) {
    }
	public void windowClosing( java.awt.event.WindowEvent windowEvent ) {
		System.exit( 0 );
	}
    public void windowDeactivated( java.awt.event.WindowEvent windowEvent ) {
    }
    public void windowDeiconified( java.awt.event.WindowEvent windowEvent ) {
    }
    public void windowIconified( java.awt.event.WindowEvent windowEvent ) {
    }
    public void windowOpened( java.awt.event.WindowEvent windowEvent ) {
	    //init();
		camera = initSceneGraph();
		initRenderer( camera );
		target.scenegraphCreated();
    }
	public Camera camera;
	public void simulate( double currTime ) {
		double dt = currTime-prevTime;
		if( dt>0 ) {
			//cameraVehicle.turn( Vector3.Y_AXIS, dt*0.1, null );
			if( pickedVisual!=null && pickedVisual!=groundVisual ) {
			    Transformable trans = (Transformable)pickedVisual.getParent();
			    trans.rotate( Vector3.Z_AXIS, dt, null );
			}
		}
		prevTime = currTime;
	}


//    public void preRendered( edu.cmu.cs.stage3.alice.scenegraph.renderer.event.RenderEvent renderEvent ) {}
//    public void cleared( edu.cmu.cs.stage3.alice.scenegraph.renderer.event.RenderEvent renderEvent ) {  }
//    public void rendered( edu.cmu.cs.stage3.alice.scenegraph.renderer.event.RenderEvent renderEvent ) {  }
//    public void idle( edu.cmu.cs.stage3.alice.scenegraph.renderer.event.RenderEvent renderEvent ) {  }
//    public void swapped( edu.cmu.cs.stage3.alice.scenegraph.renderer.event.RenderEvent renderEvent ) {
//		paint((edu.cmu.cs.stage3.alice.scenegraph.renderer.RenderTarget) renderEvent.getSource());
//    }
	// RenderTargetListener
	public void cleared( edu.cmu.cs.stage3.alice.scenegraph.renderer.event.RenderTargetEvent renderTargetEvent ) {
		Suggestion.show();
	}
	public void rendered( edu.cmu.cs.stage3.alice.scenegraph.renderer.event.RenderTargetEvent renderTargetEvent ) {
		edu.cmu.cs.stage3.alice.scenegraph.renderer.RenderTarget renderTarget = (edu.cmu.cs.stage3.alice.scenegraph.renderer.RenderTarget) renderTargetEvent.getSource();
		
		java.awt.Graphics g = renderTarget.getOffscreenGraphics();
		target.paintOverlay(g);
		g.dispose();

		Suggestion.hide();
	}
	// OnscreenRenderTargetListener
	public void updated(edu.cmu.cs.stage3.alice.scenegraph.renderer.event.OnscreenRenderTargetEvent renderTargetEvent ) {}
	public void idle( edu.cmu.cs.stage3.alice.scenegraph.renderer.event.RendererEvent renderTargetEvent ) {}
	
	





	

	public void initRenderer( Camera camera ) {
        Class cls = rendererInfo.getRendererClass();
		edu.cmu.cs.stage3.alice.scenegraph.renderer.Renderer renderer = null;
		try {
	        renderer = (edu.cmu.cs.stage3.alice.scenegraph.renderer.Renderer)cls.newInstance();
		} catch( IllegalAccessException iae ) {
			iae.printStackTrace();
		} catch( InstantiationException ie ) {
			ie.printStackTrace();
		}
		if( renderer!=null ) {
			
			renderTarget = renderer.createHeavyweightOnscreenRenderTarget();
			if( renderer instanceof edu.cmu.cs.stage3.alice.scenegraph.renderer.directx7renderer.Renderer ) {
				renderTarget.setDisplayDevice( renderer.getDisplayDrivers()[0].getFirstDevice( false ) );
			}
			
//			renderTarget = renderer.createRenderTarget();
//			if (Chateau.renderername == "edu.cmu.cs.stage3.alice.scenegraph.renderer.dx7renderer.RendererInfo"){
//				edu.cmu.cs.stage3.alice.scenegraph.renderer.dx7renderer.Renderer dx7Renderer = (edu.cmu.cs.stage3.alice.scenegraph.renderer.dx7renderer.Renderer)renderer;
//				edu.cmu.cs.stage3.alice.scenegraph.renderer.dx7renderer.RenderTarget dx7RenderTarget = (edu.cmu.cs.stage3.alice.scenegraph.renderer.dx7renderer.RenderTarget)renderTarget;
//				dx7RenderTarget.setDisplayDevice( dx7Renderer.getDisplayDrivers()[0].getFirstDevice( false ) );
//			}
						
	        awtComponent = renderTarget.getAWTComponent();
	        add("Center", awtComponent );
			awtComponent.addMouseListener(target);//mouseListener);
			awtComponent.addMouseMotionListener(target);//mouseMotionListener);
			awtComponent.addKeyListener(target);//mouseMotionListener);

			Controls controls = new Controls(target);
			add("South", controls);

			invalidate();
	        doLayout();
			controls.doLayout();

//	        renderTarget.addCamera( camera );
//	        renderTarget.addRenderListener( this );

			renderTarget.addCamera( camera );
			renderTarget.addOnscreenRenderTargetListener( this );
			renderTarget.getRenderer().addRendererListener( this );
		        
			m_offscreenRenderTarget = renderer.createOffscreenRenderTarget();
			m_offscreenRenderTarget.setSize( awtComponent.getSize() );
	        m_offscreenRenderTarget.addCamera( camera );
	        
			m_offscreenRenderTarget_small = renderer.createOffscreenRenderTarget();
			m_offscreenRenderTarget_small.setSize( Suggestion.getInnerSize() );
	        m_offscreenRenderTarget_small.addCamera( camera );
		}
	}
	java.awt.Component awtComponent;










    public edu.cmu.cs.stage3.alice.scenegraph.renderer.OffscreenRenderTarget m_offscreenRenderTarget;
    public edu.cmu.cs.stage3.alice.scenegraph.renderer.OffscreenRenderTarget m_offscreenRenderTarget_small;


	public void disableUpdate(){
		renderTarget.setUpdateIsAutomatic( false );
	}
	public java.awt.Image getOffscreenImage(){
		m_offscreenRenderTarget.clearAndRenderOffscreen();//.render();
		return m_offscreenRenderTarget.getOffscreenImage();
	}
	public java.awt.Image getOffscreenImage_small(){
		Suggestion.hide();
		m_offscreenRenderTarget_small.clearAndRenderOffscreen();//.render();
		return m_offscreenRenderTarget_small.getOffscreenImage();
	}
	/*	
	public java.awt.Image getOffscreenImage(java.awt.Dimension size){
		m_offscreenRenderTarget.getAWTComponent().setSize( size );
		m_offscreenRenderTarget.render();
		return m_offscreenRenderTarget.getOffscreenImage();
	}
	*/
	public void enableUpdate(){
		renderTarget.setUpdateIsAutomatic( true );
	}
		













    public IndexedTriangleArray loadIndexedTriangleArray( String dirname ) {
        IndexedTriangleArray ita = new IndexedTriangleArray();
        try {
            java.io.InputStream is;
            is = new java.io.FileInputStream( new java.io.File( dirname+"/vertices.bin" ) );
            ita.loadVertices( is );
            is.close();
            is = new java.io.FileInputStream( new java.io.File( dirname+"/indices.bin" ) );
            ita.loadIndices( is );
            is.close();
        } catch( java.io.FileNotFoundException fnfe ) {
            fnfe.printStackTrace();
        } catch( java.io.IOException ioe ) {
            ioe.printStackTrace();
        }
        return ita;
    }


    public TextureMap loadTextureMap( String dirname ) {
		java.awt.Toolkit toolkit = getToolkit();
		java.awt.Image image = toolkit.getImage( "samples/media/ground/texture.jpg" );
		while( image.getWidth( this )==-1 && image.getWidth( this )==-1 ) {
			Thread.yield();
		}
        TextureMap textureMap = new TextureMap();
        textureMap.setImage( image );
        return textureMap;
    }



	/*
	public VisualPickInfo visualPick(Visual visual, int x, int y){
		edu.cmu.cs.stage3.alice.scenegraph.renderer.PickInfo pickInfo
  			= renderTarget.pick( x, y, edu.cmu.cs.stage3.alice.scenegraph.renderer.PickStyle.USE_GEOMETRY );

        Visual[] visuals = pickInfo.getVisuals();

		if( visuals != null && visuals.length>0){

			int n=0;
			while(visuals[n] != visual)
				n++;

			Vector4[] xyzws = pickInfo.getXYZWs();
    		int[] faces = pickInfo.getFaces();

			if (xyzws != null){
				Vector4 viewportPt = xyzws[n];
				Vector3 localPt = (renderTarget).transformFromViewport(
    								viewportPt, pickInfo.getCamera(), (ReferenceFrame)visual.getParent());
				return new VisualPickInfo(visual, localPt, faces[n]);
			}
		}
		return null;
 	}
	*/



}


