package ui;

import edu.cmu.cs.stage3.alice.scenegraph.*;
import edu.cmu.cs.stage3.math.*;

import java.awt.Graphics;
import java.awt.Point;
import java.util.*;


public class LoopCoverHelper extends Helper
{
	public Suggestion makeSuggestion(Chateau chateau){
		if (chateau.currentLines.size() <= 1)
			return null;
			
		Vector lines = chateau.currentLines;

		Plane basePlane = find_common_plane(lines);
		if (basePlane==null)
			return null;

		Line line = (Line) lines.elementAt(0);
		for(int i=0; i<line.plates.size(); i++){
			Plate plate = (Plate) line.plates.elementAt(i);
			if (Util.isSubsetVector(lines, plate.lines))	//Util.equivalentVector(lines, plate.lines))
				return null;
		}

		Joint joint0=null, joint1=null;
		if (!is_loop(lines)){
			Object[] chain = get_chain(lines);
			if (chain == null)
				return null;
			joint0 = (Joint) ((Vector)chain[1]).elementAt(0);
			joint1 = (Joint) ((Vector)chain[1]).elementAt(lines.size());
			
		}



		
		// let's make a suggestion!!	
		World originalWorld = 	new World(chateau);
		
		lines = Util.duplicateVector(lines);
		
		if (joint0 != null){
			Line newLine = chateau.addLine(new Line(joint0, joint1));
			lines.addElement(newLine);
			chateau.addCurrentLine(newLine);
		}

		chateau.addPlate(new Plate(lines));

		Suggestion suggestion = new Suggestion(chateau, "LoopCover");
		chateau.restoreWorld(originalWorld);
		return suggestion;
		
	}
	
	
}
