package ui;

import edu.cmu.cs.stage3.alice.scenegraph.*;
import edu.cmu.cs.stage3.math.*;

import java.awt.Graphics;
import java.awt.Point;
import java.util.*;


public class ResizeHelper extends Helper
{
	public Suggestion makeSuggestion(Chateau chateau){
	
		if (chateau.currentLines.size() <= 3)
			return null;
			
		Line currentLine = chateau.currentLine();
		
		Joint commonJoint = null;
		Line referenceLine = null;
		for(int i=0; i<chateau.currentLines.size()-1; i++){
			Line line = (Line) chateau.currentLines.elementAt(i);
			Joint joint = currentLine.get_common_joint(line);
			if (joint != null && line.parallel(currentLine)){
				referenceLine = line;
				commonJoint = joint;
				break;
			}
		}
		if (referenceLine == null)
			return null;
			
		Joint targetJoint = currentLine.get_the_other_joint(commonJoint);
		Joint referenceJoint = referenceLine.get_the_other_joint(commonJoint);
		
		Vector3 vec0 = Vector3.subtract(targetJoint.position, commonJoint.position);
		Vector3 vec1 = Vector3.subtract(referenceJoint.position, commonJoint.position);
		
		if (Vector3.dotProduct(vec0, vec1) < 0)
			return null;

		Vector3 vector = vec0;
		vector.normalize();
		Vector3 base = commonJoint.position;
		double ratio = currentLine.getLength()/referenceLine.getLength();










		// let's make a suggestion!!	
		World originalWorld = 	new World(chateau);

		Vector lines = Util.duplicateVector(chateau.currentLines);
		
		Vector plates = new Vector();
		for(int i=0; i<chateau.plates.size(); i++){
			Plate plate = (Plate) chateau.plates.elementAt(i);
			if (Util.isSubsetVector(plate.lines, lines))
				plates.addElement(plate);
		}
		
		
		for(int i=0; i<plates.size(); i++){
			Plate plate = (Plate) plates.elementAt(i);
			chateau.deletePlate(plate);
		}
		
		for(int i=0; i<lines.size(); i++){
			Line line = (Line) lines.elementAt(i);
			chateau.deleteLine(line);
		}

		Hashtable hash = new Hashtable();
		for(int i=0; i<lines.size()-1; i++){
			Line line = (Line) lines.elementAt(i);
			Joint startJoint = chateau.findJoint(transform(line.start, base, vector, ratio));
			Joint endJoint = chateau.findJoint(transform(line.end, base, vector, ratio));
			
			Line newLine = chateau.addLine(new Line(startJoint, endJoint));
			chateau.addCurrentLine(newLine);
			
			hash.put(line, newLine);
		}

		for(int i=0; i<plates.size(); i++){
			Plate plate = (Plate) plates.elementAt(i);
			Vector l = new Vector();
			for(int j=0; j<plate.lines.size(); j++)
				l.addElement(hash.get(plate.lines.elementAt(j)));
			chateau.addPlate(new Plate(l));
		}



		Suggestion suggestion = new Suggestion(chateau, "Resize");
		chateau.restoreWorld(originalWorld);
		return suggestion;
	}
	
	public Vector3 transform(Vector3 p, Vector3 base, Vector3 vector, double ratio){
		double t = Vector3.dotProduct(vector, Vector3.subtract(p, base));
		if (t<Chateau.ERROR)
			t = 0;
		return Vector3.add(p, Vector3.multiply(vector, t*(ratio-1)));
	}

}
