package ui;


import java.awt.*;
import java.util.Vector;

import edu.cmu.cs.stage3.alice.scenegraph.*;
import edu.cmu.cs.stage3.math.*;

public class Suggestion
{
	static final int WIDTH =  180;//240;//120;
	static final int HEIGHT = 120;//200;//100;
	static final int PREVIEW_FRAME = 20;
	static final int margin = 2;
	static public Dimension getSize(){
		return new Dimension(WIDTH, HEIGHT);
	}
	static public Dimension getInnerSize(){
		return new Dimension(WIDTH-margin*2, HEIGHT-margin*2);
	}
	
	
	World world;
	String name;
	java.awt.Component awtComponent;
	Image fullImage;
	Image thumbnailImage;


	Suggestion(Chateau chateau, String name){
		this.world = new World(chateau);
		this.awtComponent = Chateau.jaliceFrame.awtComponent;
		this.name = name;
		System.out.println("Suggestion: "+name);
		
		//fullImage = Chateau.jaliceFrame.getOffscreenImage();//awtComponent.getSize());
		Suggestion.hide();
		Image smallImage = Chateau.jaliceFrame.getOffscreenImage_small();//getInnerSize());
		
		thumbnailImage = awtComponent.createImage(WIDTH, HEIGHT);
		Graphics g = thumbnailImage.getGraphics();
		g.drawImage(smallImage, margin, margin, null);
		g.dispose();
		
		construct();
	}



//	Suggestion(World world, String name, Image offscreenImage){
//		this.world = world;
//		
//		this.awtComponent = Chateau.jaliceFrame.awtComponent;
//		thumbnailImage = awtComponent.createImage(WIDTH, HEIGHT);
//		Graphics g = thumbnailImage.getGraphics();
//		g.drawImage(offscreenImage, margin, margin, null);
//		g.dispose();
//	}
	/*
	Suggestion(World world, String name){
		this.world = world;
		this.awtComponent = Chateau.jaliceFrame.awtComponent;
		image = awtComponent.createImage(WIDTH, HEIGHT);
		Graphics g = image.getGraphics();
		g.setColor(Color.black);
		g.drawString(name, 20, 40);
		g.dispose();
	}
	*/
	


	public Image getThumbnailImage(){
		return thumbnailImage;
	}
	
	Rectangle bbox;
	public void setBoundingBox(Rectangle bbox, int i){
		this.bbox = bbox;
	
//		Vector3 v0 = Chateau.jaliceFrame.screen_coords_to_local_coords(new Point(bbox.x, bbox.y), Chateau.jaliceFrame.cameraVehicle);
//		Vector3 v1 = Chateau.jaliceFrame.screen_coords_to_local_coords(new Point(bbox.x+bbox.width, bbox.y+bbox.height), Chateau.jaliceFrame.cameraVehicle);

		Vector3 zero = new Vector3(0,0,0);

		Vector3 v0 = Chateau.jaliceFrame.screen_coords_to_local_coords(new Point(bbox.x, bbox.y), Chateau.jaliceFrame.cameraVehicle);
		InfiniteLine line = new InfiniteLine(zero, Vector3.subtract(v0, zero));
		Plane plane = new Plane( new Vector3(0,0,1), new Vector3(0,0,1));
		v0 = plane.get_cross_point(line);
		
		Vector3 v1 = Chateau.jaliceFrame.screen_coords_to_local_coords(new Point(bbox.x+bbox.width, bbox.y+bbox.height), Chateau.jaliceFrame.cameraVehicle);
		line = new InfiniteLine(zero, Vector3.subtract(v1, zero));
		v1 = plane.get_cross_point(line);
		
//System.out.println(""+v0+" "+v1);		
		double w = 0.267;
		v0.x = -0.47+w*i;
		v1.x = -0.47+w*(i+1);
		Vector3[] vs = {  	new Vector3(v0.x, v0.y, v0.z),
							new Vector3(v1.x, v0.y, v0.z),
							new Vector3(v1.x, v1.y, v0.z),
							new Vector3(v0.x, v1.y, v0.z)};
		set_vertices(vs);		
	}
	public Rectangle getBoundingBox(){
		return bbox;
	}
	
	public void apply(Chateau chateau){
		chateau.restoreWorld(world);
	}

	
	Visual visual;
	IndexedTriangleArray ita;
	Transformable vehicle;
	Appearance appearance;
	void construct(){
		visual = new Visual();
		vehicle = new Transformable();
		appearance = new Appearance();
		
		vehicle.setParent(Chateau.jaliceFrame.cameraVehicle);
		vehicle.setPosition(new Vector3(0,0,0), Chateau.jaliceFrame.cameraVehicle);
		visual.setParent(vehicle);
		visual.setFrontFacingAppearance(appearance);
		//visual.setBackFacingAppearance(appearance);
	
		
	
		TextureMap modelTextureMap = new TextureMap();
		modelTextureMap.setImage( thumbnailImage );
		appearance.setDiffuseColorMap( modelTextureMap );
		appearance.setShadingStyle(ShadingStyle.NONE);
		
		double s = 10;
		Vector3[] vs = {  new Vector3(-s,-s,0),
						new Vector3(s,-s,0),
						new Vector3(s,s,0),
						new Vector3(-s,s,0)
		};
		set_vertices(vs);
		
	}
	void set_vertices(Vector3[] vs){
		
		ita = new IndexedTriangleArray();
		visual.setGeometry(ita);

		int[][] ts = { {0,1}, {1,1}, {1,0}, {0,0}};
		Vector3 normal = new Vector3(0,0,-1);
		Vertex[] vertices = new Vertex[4];
		for(int i=0; i<4; i++){
			vertices[i] = new Vertex(Vertex.POSITION_XYZ|Vertex.NORMAL_IJK|Vertex.TEXTURE_COORDINATE_UV0);
			vertices[i].setXYZ(vs[i]);
			vertices[i].setIJK(normal);
			vertices[i].setU(ts[i][0]);
			vertices[i].setV(ts[i][1]);
		}
		ita.setVertices(vertices);

		int[] indices = {0,1,2,2,3,0};
		ita.setIndices(indices);
	}
	
	static void show(){
		if (Chateau.operation_status == Chateau.NONE || Chateau.operation_status == Chateau.SUGGESTION)
		
		for(int i=0; i<Chateau.suggestions.size(); i++){
			((Suggestion)Chateau.suggestions.get(i)).vehicle.setParent(Chateau.jaliceFrame.cameraVehicle);
		}
	}
	static void hide(){
		for(int i=0; i<Chateau.suggestions.size(); i++){
			((Suggestion)Chateau.suggestions.get(i)).vehicle.setParent(null);
		}
	}
}
