package ui;

import edu.cmu.cs.stage3.alice.scenegraph.*;
import edu.cmu.cs.stage3.math.*;

import java.awt.Graphics;
import java.awt.Point;
import java.util.*;


public class TrimLineHelper extends Helper
{
	public Suggestion makeSuggestion(Chateau chateau){
	
		if (chateau.currentLines.size() != 2) 
			return null;

		Line line0 = (Line) chateau.currentLines.elementAt(1);	
		Line line1 = (Line) chateau.currentLines.elementAt(0);	
		
		if (line0.connected(line1))
			return null;
			
		Vector3 cross_point = line0.getCrossPoint(line1);
		if (cross_point == null)
			return null;
		
		
		
			
		// let's make a suggestion!!	
		World originalWorld = 	new World(chateau);
		
		Joint crossJoint = chateau.findJoint(cross_point);
		
		if (crossJoint != line0.startJoint && crossJoint != line0.endJoint){
			chateau.addCurrentLine(chateau.addLine(new Line(crossJoint, line0.startJoint)));
			chateau.addCurrentLine(chateau.addLine(new Line(crossJoint, line0.endJoint)));
			chateau.deleteLine(line0);
		} 

		if (crossJoint != line1.startJoint && crossJoint != line1.endJoint){
			chateau.addCurrentLine(chateau.addLine(new Line(crossJoint, line1.startJoint)));
			chateau.addCurrentLine(chateau.addLine(new Line(crossJoint, line1.endJoint)));
			chateau.deleteLine(line1);
		} 

		
		Suggestion suggestion = new Suggestion(chateau, "Trim");
		chateau.restoreWorld(originalWorld);
		return suggestion;
	}


}
