package ui;

import edu.cmu.cs.stage3.alice.scenegraph.*;
import edu.cmu.cs.stage3.math.*;

import java.awt.Graphics;
import java.awt.Point;
import java.util.*;


public class TrimPlateHelper extends Helper
{
	public Suggestion makeSuggestion(Chateau chateau){

		if (chateau.currentLines.size() != 2)
			return null;

		Line line0 = (Line) chateau.currentLines.elementAt(0);
		Line line1 = (Line) chateau.currentLines.elementAt(1);

		Line originalEdge = null;
		Line targetEdge = null;
		Line startEdge = null;
		Line endEdge = null;
		Plate topPlate = null;
		
		for(int i=0; i<line0.plates.size(); i++){
			Plate plate = (Plate) line0.plates.elementAt(i);
			Line prevLine = plate.findNextLine(line0.startJoint, line0);
			Line nextLine = plate.findNextLine(line0.endJoint, line0);
			
			if (plate.lines.contains(line1))
				return null;
				
			if (prevLine.on_line_segment(line1.start) && 
				nextLine.on_line_segment(line1.end)){
				originalEdge = line0;
				targetEdge = line1;
				startEdge = prevLine;
				endEdge = nextLine;
				topPlate = plate;
				break;	
			}
			else if (prevLine.on_line_segment(line1.end) && 
				nextLine.on_line_segment(line1.start)){
				originalEdge = line0;
				targetEdge = line1;
				startEdge = nextLine;
				endEdge = prevLine;
				topPlate = plate;
				break;	
			}
		}

		if (originalEdge == null)
		for(int i=0; i<line1.plates.size(); i++){
			Plate plate = (Plate) line1.plates.elementAt(i);
			Line prevLine = plate.findNextLine(line1.startJoint, line1);
			Line nextLine = plate.findNextLine(line1.endJoint, line1);
			
			if (prevLine.on_line_segment(line0.start) && 
				nextLine.on_line_segment(line0.end)){
				originalEdge = line1;
				targetEdge = line0;
				startEdge = prevLine;
				endEdge = nextLine;
				topPlate = plate;
				break;	
			}
			else if (prevLine.on_line_segment(line0.end) && 
				nextLine.on_line_segment(line0.start)){
				originalEdge = line1;
				targetEdge = line0;
				startEdge = nextLine;
				endEdge = prevLine;
				topPlate = plate;
				break;	
			}
		}

		if (originalEdge == null)
			return null;
			
			
			
		
		
		
		





		
		// let's make a suggestion!!	
		World originalWorld = 	new World(chateau);

		Joint startEdge_joint0 = startEdge.get_common_joint(originalEdge);
		Joint startEdge_joint1 = startEdge.get_the_other_joint(startEdge_joint0);
		Line newStartEdge = null;
		if (startEdge_joint1 != targetEdge.startJoint)
			newStartEdge = chateau.addLine(new Line(startEdge_joint1, targetEdge.startJoint));
			
		Joint endEdge_joint0 = endEdge.get_common_joint(originalEdge);
		Joint endEdge_joint1 = endEdge.get_the_other_joint(endEdge_joint0);
		Line newEndEdge = null;
		if (endEdge_joint1 != targetEdge.endJoint)
			newEndEdge = chateau.addLine(new Line(endEdge_joint1, targetEdge.endJoint));

		Vector topLines = Util.duplicateVector(topPlate.lines);
		topLines.removeElement(originalEdge);
		topLines.removeElement(startEdge);
		topLines.removeElement(endEdge);
		topLines.addElement(targetEdge);
		if (newStartEdge != null)
			topLines.addElement(newStartEdge);
		if (newEndEdge != null)
			topLines.addElement(newEndEdge);
		chateau.addPlate(new Plate(topLines));

		chateau.deletePlate(topPlate);
		chateau.deleteLine(originalEdge);
		chateau.deleteLine(startEdge);
		chateau.deleteLine(endEdge);


		Suggestion suggestion = new Suggestion(chateau, "TrimPlate");
		chateau.restoreWorld(originalWorld);
		return suggestion;
		
	}
	
}
