package ui;

import java.util.*;
import edu.cmu.cs.stage3.math.*;

public class Util {

	static public Vector reverseVector(Vector vector) {
		Vector new_vector = new Vector();
		int size = vector.size();
		for(int i=0; i<size; i++)
			new_vector.addElement(vector.elementAt(size-i-1));
		return new_vector;
    }
	static public Vector duplicateVector(Vector vector) {
		return (Vector) vector.clone();
		/*
		Vector new_vector = new Vector();
		int size = vector.size();
		for(int i=0; i<size; i++)
			new_vector.addElement(vector.elementAt(i));
		return new_vector;
		*/
    }
	static public Vector connectVector(Vector vector0, Vector vector1) {
		Vector new_vector = duplicateVector(vector0);
		int size = vector1.size();
		for(int i=0; i<size; i++)
			new_vector.addElement(vector1.elementAt(i));
		return new_vector;
    }
	static public Vector appendVector(Vector vector0, Vector vector1) {
		int size = vector1.size();
		for(int i=0; i<size; i++)
			vector0.addElement(vector1.elementAt(i));
		return vector0;
    }
    static public boolean isSubsetVector(Vector a, Vector b){
		for(int i=0; i<a.size(); i++)
			if (!b.contains(a.elementAt(i)))
				return false;
		return true;
    }
    
    
	static public int mod(int n, int m){
		while(n<0 || n>=m){
			if (n>=m)	n -= m;
			if (n<0)	n += m;
		}
		return n;
	}
	
	static public boolean equivalentVector(Vector v0, Vector v1){
		if (v0.size() != v1.size())
			return false;
		for(int i=0; i<v0.size(); i++){
			Object a = v0.elementAt(i);
			if (!v1.contains(a))
				return false;
		}
		return true;
	}
	static public void printVector(Vector vector) {
		int size = vector.size();
		for(int i=0; i<size; i++)
			System.out.print(","+vector.elementAt(i));
		System.out.println("");
    }
    
    
    
    
    
    
    
    
    static public double signedAngle180(Vector3 v0, Vector3 v1, Vector3 normal){
    	double cos = Vector3.dotProduct(v0, v1) / (v0.getLength() * v1.getLength());
    	double angle = 180 * Math.acos(cos) / Math.PI;	
    	
    	Vector3 n = Vector3.crossProduct(v0, v1);
    	if (Vector3.dotProduct(n, normal) >0)
    		return angle;
    	else
    		return -angle;
    }
    static public double angle180(Vector3 v0, Vector3 v1){
    	double cos = Vector3.dotProduct(v0, v1) / (v0.getLength() * v1.getLength());
    	double angle = 180 * Math.acos(cos) / Math.PI;	
    	return angle;
    }
    static public Vector3 rotate(Vector3 v, double angle, Vector3 normal){
    	normal = Vector3.normalizeV(normal);
    	Vector3 n1 = Vector3.crossProduct(normal, v);
    	Vector3 n0 = Vector3.crossProduct(n1, normal);
    	Vector3 dz = Vector3.subtract(v, n0);
    	
    	Vector3 n = Vector3.add(Vector3.multiply(n0, Math.cos(Math.PI*angle/180)),
    							Vector3.multiply(n1, Math.sin(Math.PI*angle/180)));
    				
    	return Vector3.add(n, dz);
	}    

}