package ui;

import edu.cmu.cs.stage3.alice.scenegraph.*;
import edu.cmu.cs.stage3.math.*;



public class Walkthrough {

	public Vector3 position = new Vector3(0,-1,0);
	public Vector3 direction = new Vector3(1,0,0);
	public double speed = 0.1;
	
	CenterBall avatar;
	
	Chateau chateau;
	
	Walkthrough(Chateau chateau){
		this.chateau = chateau;
		
		avatar = new CenterBall(position);
		avatar.addToScenegraph(chateau.jaliceFrame.scene);		
		
	}


	/*
	//{avatar_pos, camera_pos, camera_height, camera_angle
	double[] setting = {0.0, -1.5, 0.5, 0};	// avatar_center
	//double[] setting = {1.5, 0, 0.5, 0};	// camera_center
	////double[] setting = {1.5, 0, 1, -0.3};	// look down

	public Vector3 camera_position = Vector3.add(position, Vector3.multiply(direction, setting[1]));
	public void repaint(){
		avatar.jointVehicle.setPosition(position, null);
		avatar.jointVehicle.setOrientation(direction, Vector3.Y_AXIS, null);

		Vector3 elevated_camera_position = Vector3.add(camera_position, new Vector3(0,setting[2],0));	//0.5	//0.1 肬
		chateau.jaliceFrame.cameraVehicle.setPosition(elevated_camera_position, null);
		
		Vector3 camera_direction = Vector3.subtract(position, camera_position);
		camera_direction = Vector3.add(camera_direction, new Vector3(0,setting[3],0));			//-0.2
		chateau.jaliceFrame.cameraVehicle.setOrientation(camera_direction, Vector3.Y_AXIS, null);
	
		chateau.repaint();
	}

	public void move_forward(){
		move_sub(speed);
	}
	public void move_backward(){
		move_sub(-speed);
	}
	public void move_sub(double amount){

		Vector3 goal_position = Vector3.add(position, Vector3.multiply(direction, amount));
		
		Line line = new Line(goal_position, position);
		if (intersect_with_wall(line) != null){
			return;
		}
		position = goal_position;
		
		
		Vector3 goal_camera_position = Vector3.add(position, Vector3.multiply(direction, setting[1]));

		line = new Line(goal_camera_position, position);
		Line wall_line = intersect_with_wall(line);
		if (wall_line == null){
			camera_position = goal_camera_position;
		}
		else {
			Circle circle = new Circle(position, Math.abs(setting[1]));
			InfiniteLine l = new InfiniteLine(wall_line);
			Vector3[] ps = circle.crossPoints(l);
			camera_position = closest(ps, camera_position);

		}
		
		repaint();
	}
	Vector3 closest(Vector3[] ps, Vector3 pos){
		double min = 100000;
		Vector3 result = null;
		for(int i=0; i<ps.length; i++){
			double d = Vector3.subtract(ps[i], pos).getLength();
			if (d<min){
				min = d;
				result = ps[i];
			}
		}
		return result;
	}



	public void turn_left(){
		turn_sub(5);
	}
	public void turn_right(){
		turn_sub(-5);
	}
	public void turn_sub(double angle){
		teddy.Vector2 vec = new teddy.Vector2(direction.x, direction.z);
		vec = vec.rotate(angle);
		direction.x = vec.x;
		direction.z = vec.y;
	
		Vector3 goal_camera_position = Vector3.add(position, Vector3.multiply(direction, setting[1]));

		Line line = new Line(goal_camera_position, position);
		if (intersect_with_wall(line) == null){
			camera_position = goal_camera_position;
		}


		repaint();
	}


	public Line intersect_with_wall(Line line){			
		teddy.Segment segment = new teddy.Segment(line.start.x, line.start.z, line.end.x, line.end.z);
		for(int i=0; i<chateau.ground.lines.size(); i++){
			Line l = (Line)chateau.ground.lines.elementAt(i);
			teddy.Segment seg = new teddy.Segment(l.start.x, l.start.z, l.end.x, l.end.z);
			if (segment.cross(seg))
				return l;			
		}
		return null;
		
	}
*/

	//{avatar_pos, camera_pos, camera_height, camera_angle
	//double[] setting = {0.0, -1.5, 0.5, 0};	// avatar_center
	double[] setting = {1.0, 0, 0.5, 0};	// camera_center	// near = 0.8
	////double[] setting = {1.5, 0, 1, -0.3};	// look down
	
	public void repaint(){
		Vector3 vec;
		
		vec = Vector3.add(position, Vector3.multiply(direction, setting[0]));	
		avatar.jointVehicle.setPosition(vec, null);
		avatar.jointVehicle.setOrientation(direction, Vector3.Y_AXIS, null);

		vec = Vector3.add(position, Vector3.multiply(direction, setting[1]));	
		Vector3 camera_position = Vector3.add(vec, new Vector3(0,setting[2],0));	//0.5	//0.1 肬
		chateau.jaliceFrame.cameraVehicle.setPosition(camera_position, null);
		
		vec = Vector3.add(direction, new Vector3(0,setting[3],0));			//-0.2
		chateau.jaliceFrame.cameraVehicle.setOrientation(vec, Vector3.Y_AXIS, null);
	
		chateau.jaliceFrame.update_light_position();
		
		chateau.repaint();
	}

	public void move_forward(){
		move_sub(speed);
	}
	public void move_backward(){
		move_sub(-speed);
	}
	public void move_sub(double amount){
		Vector3 prev_avatar_position = Vector3.add(position, Vector3.multiply(direction, setting[0]));	
		Vector3 prev_camera_position = Vector3.add(position, Vector3.multiply(direction, setting[1]));	

		Vector3 goal_position = Vector3.add(position, Vector3.multiply(direction, amount));
		Vector3 camera_position = Vector3.add(goal_position, Vector3.multiply(direction, setting[1]));	
		Vector3 avatar_position = Vector3.add(goal_position, Vector3.multiply(direction, setting[0]));	

		
		Line line = new Line(prev_avatar_position, avatar_position);
		Line line2 = new Line(prev_camera_position, camera_position);
		if (intersect_with_wall(line, line2)){
			return;
		}
		
		position = goal_position;
		repaint();
	}



	public void turn_left(){
		turn_sub(5);
	}
	public void turn_right(){
		turn_sub(-5);
	}
	public void turn_sub(double angle){
		Vector3 prev_avatar_position = Vector3.add(position, Vector3.multiply(direction, setting[0]));	
	
		teddy.Vector2 vec = new teddy.Vector2(direction.x, direction.z);
		vec = vec.rotate(angle);
		direction.x = vec.x;
		direction.z = vec.y;
		
		Vector3 avatar_position = Vector3.add(position, Vector3.multiply(direction, setting[0]));	
		Line line = new Line(prev_avatar_position, avatar_position);
		Line line2 = new Line(position, avatar_position);
		if (intersect_with_wall(line, line2)){
			position.add( Vector3.subtract(prev_avatar_position, avatar_position) );
		}
		repaint();
	}


	public boolean intersect_with_wall(Line line, Line line2){			
		//teddy.Segment segment = new teddy.Segment(line.start.x, line.start.z, line.end.x, line.end.z);
		//teddy.Segment segment2 = new teddy.Segment(line2.start.x, line2.start.z, line2.end.x, line2.end.z);
		//for(int i=0; i<chateau.ground.lines.size(); i++){
		//	Line l = (Line)chateau.ground.lines.elementAt(i);
		//	teddy.Segment seg = new teddy.Segment(l.start.x, l.start.z, l.end.x, l.end.z);
		//	if (segment.cross(seg) || segment2.cross(seg))
		//		return true;			
		//}
		return false;
		
	}







	public void keyPressed(java.awt.event.KeyEvent e) {

		if (e.getKeyCode() == e.VK_UP){
			move_forward();
		}
		else if (e.getKeyCode() == e.VK_DOWN){
			move_backward();
		}
		else if (e.getKeyCode() == e.VK_LEFT){
			turn_left();
		}
		else if (e.getKeyCode() == e.VK_RIGHT){
			turn_right();
		}
		else if (e.getKeyCode() == e.VK_SPACE){
			//System.out.println(""+chateau.jaliceFrame.camera.getNearClippingPlaneDistance());
		if (chateau.jaliceFrame.camera.getNearClippingPlaneDistance()==0.125)
			chateau.jaliceFrame.camera.setNearClippingPlaneDistance(0.08);
		else		
			chateau.jaliceFrame.camera.setNearClippingPlaneDistance(0.125);
		}
	}
	
	

}