package ui;

import edu.cmu.cs.stage3.alice.scenegraph.*;
import edu.cmu.cs.stage3.math.*;

import java.awt.Graphics;
import java.awt.Point;
import java.util.*;

public class World 
{
	// Vector candidate_lines = new Vector();
	// Line primary_candidate_line;

	
	Vector joints = new Vector(); 		
	Vector lines = new Vector();
	Vector plates = new Vector();
	Vector planes = new Vector();
	
	Plane currentPlane;
	Vector currentLines = new Vector();

	
	// duplicate network
	World(Chateau chateau){
		//long time = System.currentTimeMillis();

		Hashtable hash = new Hashtable();
     	
		for(int i=0; i<chateau.joints.size(); i++){
			Joint original_joint = (Joint) chateau.joints.elementAt(i);
			Joint joint = original_joint.duplicate();
			joints.addElement(joint);
			hash.put(original_joint, joint);
		}
		for(int i=0; i<chateau.lines.size(); i++){
			Line original_line = (Line) chateau.lines.elementAt(i);
			Line line = original_line.duplicate();
			lines.addElement(line);
			hash.put(original_line, line);
		}
		for(int i=0; i<chateau.plates.size(); i++){
			Plate original_plate = (Plate) chateau.plates.elementAt(i);
			Plate plate = original_plate.duplicate();
			plates.addElement(plate);
			hash.put(original_plate, plate);
		}
		for(int i=0; i<chateau.planes.size(); i++){
			Plane original_plane = (Plane) chateau.planes.elementAt(i);
			Plane plane = original_plane.duplicate();
			planes.addElement(plane);
			hash.put(original_plane, plane);
		}
		
		// refresh network
		for(int i=0; i<joints.size(); i++){
			Joint joint = (Joint) joints.elementAt(i);
			joint.refresh_network(hash);
		}
		for(int i=0; i<lines.size(); i++){
			Line line = (Line) lines.elementAt(i);
			line.refresh_network(hash);
		}
		for(int i=0; i<plates.size(); i++){
			Plate plate = (Plate) plates.elementAt(i);
			plate.refresh_network(hash);
		}
		for(int i=0; i<planes.size(); i++){
			Plane plane = (Plane) planes.elementAt(i);
			plane.refresh_network(hash);
		}
		
		if (chateau.currentPlane != null)
			currentPlane = (Plane) hash.get(chateau.currentPlane);


		currentLines = new Vector();
		for(int i=0; i<chateau.currentLines.size(); i++){
			Line line = (Line) chateau.currentLines.elementAt(i);
			currentLines.addElement((Line)hash.get(line));
		}
		

		
	}




























	
}
